import type { IGomokuCandidateState, IMinimaxSearcher, IMinimaxSearcherContext } from '../types';
export interface IAlphaBetaSearcherProps {
    MAX_CANDIDATE_COUNT: number;
    MIN_PROMOTION_SCORE: number;
    MIN_MULTIPLE_OF_TOP_SCORE: number;
    searchContext: IMinimaxSearcherContext;
    deeperSearcher: IMinimaxSearcher;
}
export declare class AlphaBetaSearcher {
    readonly MAX_CANDIDATE_COUNT: number;
    readonly MIN_PROMOTION_SCORE: number;
    readonly MIN_MULTIPLE_OF_TOP_SCORE: number;
    readonly searchContext: Readonly<IMinimaxSearcherContext>;
    readonly deeperSearcher: IMinimaxSearcher;
    protected readonly _candidateCache: IGomokuCandidateState[];
    constructor(props: IAlphaBetaSearcherProps);
    search(ownPlayerId: number, alpha: number, beta: number): {
        bestMoveId: number | -1;
    };
}
