import type { IGomokuCandidateState, IMinimaxSearcher, IMinimaxSearcherContext } from '../types';
export interface INarrowSearcherProps {
    MAX_SEARCH_DEPTH: number;
    MAX_CANDIDATE_COUNT: number;
    MIN_PROMOTION_SCORE: number;
    MIN_MULTIPLE_OF_TOP_SCORE: number;
    searchContext: IMinimaxSearcherContext;
    deeperSearcher: IMinimaxSearcher;
}
export declare class NarrowSearcher implements IMinimaxSearcher {
    readonly MAX_SEARCH_DEPTH: number;
    readonly MAX_CANDIDATE_COUNT: number;
    readonly MIN_PROMOTION_SCORE: number;
    readonly MIN_MULTIPLE_OF_TOP_SCORE: number;
    readonly searchContext: Readonly<IMinimaxSearcherContext>;
    readonly deeperSearcher: IMinimaxSearcher;
    protected readonly _candidatesListCache: Record<number, IGomokuCandidateState[]>;
    constructor(props: INarrowSearcherProps);
    search(nextPlayerId: number, alpha: number, beta: number, cur: number): number;
    protected _getCandidates(cur: number): IGomokuCandidateState[];
}
