import type { IGomokuContext } from './context.type';
import type { IGomokuCountMap } from './count-map.type';
import { AlphaBetaSearcher } from './search/alpha-beta';
import type { IGomokuState } from './state.type';
import type { IGomokuPiece, IMinimaxSearcher, IMinimaxSearcherContext, IShapeScoreMap } from './types';
export interface IGomokuSolutionProps {
    MAX_ROW: number;
    MAX_COL: number;
    MAX_ADJACENT?: number;
    MAX_DISTANCE_OF_NEIGHBOR?: number;
    MIN_MULTIPLE_OF_TOP_SCORE?: number;
    scoreMap?: IShapeScoreMap;
    deeperSearcher?(searcherContext: IMinimaxSearcherContext): IMinimaxSearcher;
}
export declare class GomokuSolution {
    readonly MIN_MULTIPLE_OF_TOP_SCORE: number;
    readonly context: Readonly<IGomokuContext>;
    readonly countMap: Readonly<IGomokuCountMap>;
    readonly state: Readonly<IGomokuState>;
    protected readonly _alphaBeta: AlphaBetaSearcher;
    constructor(props: IGomokuSolutionProps);
    init(pieces: ReadonlyArray<IGomokuPiece>): void;
    forward(r: number, c: number, playerId: number): void;
    revert(r: number, c: number): void;
    minimaxSearch(nextPlayerId: number): [r: number, c: number];
}
